
 
function love.load()

	medium = love.graphics.newFont("Assets/DNGfont.ttf",25)	
	
	gamestate = "menu"												
	buttonSpawn(100, 100, "Start", "start")
	buttonSpawn(100, 120, "Options", "options")
	buttonSpawn(100, 140, "Quit", "quit")
	loadMap('/Maps/level1.lua')
end

----------------------------------------------------------------
function love.update(dt)											--Update means it Updates every frame (Too much leads to lag)
	mousex = love.mouse.getX()
	mousey = love.mouse.getY()
	if gamestate == "playing" then
		backMenu()
		playerMove(dt)
	end

	if gamestate == "menu" then
		buttonCheck() -- For Highlighting
	end
	
	if gamestate == "options" then

	end
	
end
----------------------------------------------------------------
function love.draw() 												--Draw is for graphics
	if gamestate == "playing" then
		drawMap()
		playerDraw()
	end

	if gamestate == "menu" then
		buttonDraw()
	end
	
	if gamestate == "options" then

	end		
end




----------------------------------------------------------------------------------
----------------------------------------------------------------------------------
---------------------CODE YONDER--------------------------------------------------
----------------------------------------------------------------------------------
----------------------------------------------------------------------------------

function loadMap(path)
  local f = love.filesystem.load(path) -- obtain a function
  f() -- run a function
end


------------------------------------------------------------------------------
function newMap(tileW, tileH, tileSetPath, quadInfo, tileString)

  TileW = tileW
  TileH = tileH
  Tileset = love.graphics.newImage(tileSetPath)
  
  local tilesetW, tilesetH = Tileset:getWidth(), Tileset:getHeight()

  
Quads = {}
for i,info in ipairs(quadInfo) do
  Quads[info[1]] = love.graphics.newQuad(info[2], info[3], TileW, TileH, tilesetW, tilesetH)
end

----------------------------------------------------------------------------------------
--                                      Separator                                     --
----------------------------------------------------------------------------------------
  local tilesetW, tilesetH = Tileset:getWidth(), Tileset:getHeight()
  
  Quads = {}
  for _,info in ipairs(quadInfo) do
    -- info[1] = character, info[2] = x, info[3] = y
    Quads[info[1]] = love.graphics.newQuad(info[2], info[3], TileW, TileH, tilesetW, tilesetH)
  end

  TileTable = {}
  
  local width = #(tileString:match("[^\n]+"))
  
  for x = 1,width,1 do TileTable[x] = {} end

  local x,y = 1,1
  for row in tileString:gmatch("[^\n]+") do
    x = 1
    for character in row:gmatch(".") do
      TileTable[x][y] = character
      x = x + 1
    end
    y=y+1
  end
end

 
 function drawMap()
 local Tileset = love.graphics.newImage('Assets/Tileset.png')
local TileW, TileH = 20,20
local tilesetW, tilesetH = Tileset:getWidth(), Tileset:getHeight()


  for columnIndex,column in ipairs(TileTable) do
    for rowIndex,char in ipairs(column) do
      local x,y = (columnIndex-1)*TileW, (rowIndex-1)*TileH
      love.graphics.drawq(Tileset, Quads[char], x, y)
    end
  end
  end
  
  
  -----------------------------------------------------------------------
  ------------------------------------------------------------------------
  ------------------------------------------------------------------------
  
button = {}
function buttonSpawn(x,y,text,id)														--Main menu Code
	table.insert(button, {x = x, y = y, text = text, id = id, mouseover = false})
end

function buttonDraw()
	for i,v in ipairs(button) do
	
		if v.mouseover == false then
		love.graphics.setColor(255,255,255)
		end
		
		if v.mouseover == true then
		love.graphics.setColor(255,0,0)
		end
		
		love.graphics.setFont(medium)
		love.graphics.print(v.text, v.x, v.y)
	end
end

function buttonClick(x,y)
	for i,v in ipairs(button) do
		if x > v.x and
		 x < v.x + medium:getWidth(v.text) and
		 y > v.y and
		 y < v.y + medium:getHeight() then
			if v.id == "quit" then
				love.event.push("quit")
			end
			if v.id == "start" then
				gamestate = "playing"
			end
			if v.id == "options" then
				gamestate = "options"
			end
		end		
	end
end

function buttonCheck()
	for i,v in ipairs(button) do
		if mousex > v.x and
		 mousex < v.x + medium:getWidth(v.text) and
		 mousey > v.y and
		 mousey < v.y + medium:getHeight() then
			v.mouseover = true
		else
			v.mouseover = false
		end
	end
end

function backMenu()   
   if love.keyboard.isDown("escape") then
		gamestate = "menu"
   end
end

function love.mousepressed(x,y)
	if gamestate == "playing" then

	end
	
	if gamestate == "menu" then
		buttonClick(x,y)
	end
end

-------------------------------------------------------
-------------------------------------------------------


player = {}
player.x = 10
player.y = 10
player.speed = 60
player.health = 20
player.damage = 2

player.pic = love.graphics.newImage("Assets/player.png")

function playerDraw()
	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(player.pic, player.x, player.y)
end

function playerMove(dt)
	if love.keyboard.isDown("right") then
	player.x = player.x + player.speed * dt
	end
	
	if love.keyboard.isDown("left") then
	player.x = player.x - player.speed * dt
	end

	if love.keyboard.isDown("up") then
	player.y = player.y - player.speed * dt
	end
	
	if love.keyboard.isDown("down") then
	player.y = player.y + player.speed * dt
	end
end

